var tonyImageSearchEdit ={   

	existingAttrObjs:[],
	existingSearchAttrObjs:[],
	
	init:function(){ 
		
		this.tabSetup(); 
		
		this.removeText = $('#imageSearch_removeLinkText').val();
		this.withLabelText = $('#imageSearch_withLabelText').val();
		
		this.detailsList = $('#imageSearchAvailableAttributes');
		this.searchAttrsList = $('#imageSearch_searchAttributes'); 
		
		$('input[name=mode]').each(function(i,el){ 								
			$(el).click(function(){ tonyImageSearchEdit.showSearchOptions(); } );
			$(el).change(function(){ tonyImageSearchEdit.showSearchOptions(); } );
		});	
		
		$('input[name=linkMode]').each(function(i,el){ 								
			$(el).click(function(){ tonyImageSearchEdit.showLinkModeOptions(); } );
			$(el).change(function(){ tonyImageSearchEdit.showLinkModeOptions(); } );
		});	
		
	},
	
	tabSetup: function(){
		$('ul#ccm-blockEditPane-tabs li a').each( function(num,el){ 
			el.onclick=function(){ 
				var pane=this.id.replace('ccm-blockEditPane-tab-',''); 
				tonyImageSearchEdit.showPane(pane);
			}
		});		
	},
	showPane:function(pane){
		$('ul#ccm-blockEditPane-tabs li').each(function(num,el){ $(el).removeClass('ccm-nav-active') });
		$(document.getElementById('ccm-blockEditPane-tab-'+pane).parentNode).addClass('ccm-nav-active');
		$('div.ccm-blockEditPane').each(function(num,el){ el.style.display='none'; });
		$('#ccm-blockEditPane-'+pane).css('display','block'); 
	},	
	
	showLinkModeOptions:function(){
		var d = ($('input[name=linkMode]:checked').val()!='link') ? 'none':'block'; 
		$('#imageSearch_linkModePageLinkOptions').css('display',d);  
	},
	
	showSearchOptions:function(){
		var d = ($('input[name=mode]:checked').val()=='results') ? 'none':'block'; 
		$('#imageSearch_searchOptions').css('display',d); 
		var d = ($('input[name=mode]:checked').val()=='search') ? 'none':'block'; 
		//$('#ccm-blockEditPane-results').css('display',d); 
		$('#ccm-blockEditPane-tab-resultsWrap').css('display',d); 
	},

	showSortByAttrs:function(cb){
		var d = (cb.checked) ? 'block':'none'; 
		$('#imageSearch_sortByAttrsWrap').css('display',d); 
	},
	
	addExisting:function(){ 
		for(var i=0;i<this.existingAttrObjs.length;i++){ 
			tonyImageSearchEdit.addAttributeRowHTML( this.existingAttrObjs[i].handle, this.existingAttrObjs[i].nm, this.existingAttrObjs[i].labelShown  );
		} 
		this.makeSortable(); 
	},
	
	addExistingSearchAttrs:function(){
		for(var i=0;i<this.existingSearchAttrObjs.length;i++){ 
			tonyImageSearchEdit.addSearchAttrRowHTML( this.existingSearchAttrObjs[i].handle, this.existingSearchAttrObjs[i].nm  );
		} 
		this.makeSortable();
	}, 
	
	makeSortable:function(){
		this.detailsList.sortable({
			cursor: 'move',
			opacity: 0.5,
		}); 		
	},
	
	makeSearchAttrsSortable:function(){
		this.searchAttrsList.sortable({
			cursor: 'move',
			opacity: 0.5,
		}); 		
	}, 
	
	addAttribute:function(){
		var selOpt = $('#imageSearch_attributeSelector option:selected'); 
		var val = selOpt.val()
		if( val && val!='none' && !$('#imageSearch_detailRow'+val).html() ) { 
			this.addAttributeRowHTML( val , selOpt.html(), 0  );
		}
		
		$('#imageSearch_attributeSelector option[value=none]').attr('selected','selected') ;
		
		this.makeSortable();
		//this.detailsOptionsShown();
	}, 
	
	addSearchAttribute:function(){  
		var selOpt = $('#imageSearch_searchAttrsSelector option:selected'); 
		var val = selOpt.val();  
		if( val && val!='none' && !$('#imageSearch_searchAttrRow'+val).html() ) {  
			this.addSearchAttrRowHTML( val , selOpt.html(), 0  );
		} 
		$('#imageSearch_searchAttrsSelector option[value=none]').attr('selected','selected'); 
		this.makeSearchAttrsSortable();
		//this.detailsOptionsShown();
	},	
	
	addAttributeRowHTML:function(attrHandle,attrName,labelShown){ 
		var html = '<div class="imageSearch_detailRow" id="imageSearch_detailRow'+attrHandle+'">';
		var html = html+'<a class="fileDetails_removeRow" onclick="tonyImageSearchEdit.removeAttribute(this)">'+this.removeText+'</a>';
		var html = html+'<div class="fileDetails_withLabel">'+this.withLabelText;
		var isChecked = (labelShown) ? 'checked="checked"' : '';
		var html = html+'<input name="shownLabels[]" type="checkbox" value="'+attrHandle+'" '+isChecked+' /></div>'; 
		var html = html+'<span class="fileDetails_attrName">'+attrName+'</span>'; 
		var html = html+'<input name="shownAttrs[]" type="hidden" value="'+attrHandle+'" />'; 
		var html = html+'</div>';  
		this.detailsList.append(html); 
	},
	
	addSearchAttrRowHTML:function(attrHandle,attrName){ 
		var html = '<div class="imageSearch_detailRow" id="imageSearch_searchAttrRow'+attrHandle+'">';
		var html = html+'<a class="fileDetails_removeRow" onclick="tonyImageSearchEdit.removeAttribute(this)">'+this.removeText+'</a>'; 		
		var html = html+'<span class="fileDetails_attrName">'+attrName+'</span>';
		var html = html+'<input name="searchAttrs[]" type="hidden" value="'+attrHandle+'" />'; 
		var html = html+'</div>';
		this.searchAttrsList.append(html);
	},
	
	removeAttribute:function(a){
		$(a.parentNode).remove(); 
		//this.detailsOptionsShown();
	},	
	
	showDetailTarget:function(cb){ 
		var display=(cb.checked)?'block':'none';
		$('#ccm-image-search-detail-page-target-wrap').css('display',display);
	}, 
	
	showSearchTarget:function(cb){ 
		var display=(cb.checked)?'block':'none';
		$('#ccm-image-search-page-target-wrap').css('display',display);
	}, 
	
	//the page selector js wasn't working with multiple instances 
	setPageTarget:function(cID, cName){  
		var p = $(ccmActivePageField.parentNode); 
		p.find('input').val(cID); 
		p.find('.ccm-summary-selected-item-label').html(cName);
	},
	
	validate:function(){
		var failed=0; 
		
		if(!$('#imageSearchAvailableAttributes .imageSearch_detailRow').length){
			alert(this.attrsRequiredMsg);
			failed=1; 
		}
		
		if(failed){
			ccm_isBlockError=1;
			return false;
		} 
		return true;
	}
	
}

$(function(){ tonyImageSearchEdit.init(); });
 
ccmValidateBlockForm = function() { return tonyImageSearchEdit.validate(); }