<?php   
defined('C5_EXECUTE') or die(_("Access Denied.")); 

$uh = Loader::helper('concrete/urls'); 

$fileAttributes = FileAttributeKey::getList(); 
$attrColsArray = explode( ',', $controller->shownAttributes );

if( !function_exists('imageSearch_entities') ){ 
	function imageSearch_entities($v){ 
		$textHelper = Loader::helper('text');
		if(  method_exists($textHelper,'entities') )
			 return $textHelper->entities($v);  
		else return htmlentities($v, ENT_QUOTES, 'UTF-8'); 
	} 
} 

$setIdsArray = explode( ',', $controller->setIds );
$excludedSetIdsArray = explode( ',', $controller->excludeSetIds );
$fileSets = $controller->getDisplayableFilesSets();
$sortableByArray = explode( ',', $controller->sortByOpts ); 
?>  

<style>
#ccm-image-search-edit-pane #imageSearchAvailableAttributes, 
#ccm-image-search-edit-pane #imageSearch_searchAttributes { margin-top:8px; }
#ccm-image-search-edit-pane .imageSearch_detailRow { margin-bottom: 4px; cursor:move; border:1px solid #ddd; padding:3px 6px; background:#f6f6f6 }
#ccm-image-search-edit-pane .imageSearch_detailRow a.fileDetails_removeRow { float:right; font-size:11px; line-height:13px; padding-top:2px; }
#ccm-image-search-edit-pane .imageSearch_detailRow .fileDetails_withLabel { padding-right:16px; font-size:11px; line-height:13px; color:#666; float:right  }
#ccm-image-search-edit-pane #imageSearch_manualSelectWrap { padding-top:4px; padding-bottom:8px; }
#ccm-image-search-edit-pane #imageSearch_qStrSelectWrap { padding-top:4px; }
#ccm-image-search-edit-pane .imageSearch_colorPickerWrap { float:left; padding-right:16px; }
#ccm-image-search-edit-pane .imageSearch_setListLimitHeight { /*overflow: hidden; overflow-x: auto; overflow-y: auto; height:auto; max-height:50px; border:1px solid #ccc; padding:2px;*/ }
</style>


<div id="ccm-image-search-edit-pane" class="ccm-image-search-edit-pane"> 

    <ul id="ccm-blockEditPane-tabs" class="ccm-dialog-tabs"> 
        <li class="ccm-nav-active"><a id="ccm-blockEditPane-tab-search"  href="javascript:void(0);"><?php   echo t('Search Options')?></a></li> 
        <li class="" id="ccm-blockEditPane-tab-resultsWrap" style="display:<?php echo ($controller->mode!='search')?'block':'none' ?>"><a id="ccm-blockEditPane-tab-results"  href="javascript:void(0);"><?php   echo t('Results')?></a></li> 
    </ul>

 	<div id="ccm-blockEditPane-search" class="ccm-blockEditPane">
	
		<input id="imageSearch_removeLinkText" name="removeLinkText" type="hidden" value="<?php echo  imageSearch_entities( t('Remove') ) ?>" /> 
		<input id="imageSearch_withLabelText" name="withLabelText" type="hidden" value="<?php echo  imageSearch_entities( t('Show Label') ) ?>" />  
	 
		<div class="ccm-block-field-group">
			<h2><?php  echo t('Mode') ?></h2>
			
			<div> 
				<input name="mode" type="radio" value="full" <?php echo ($controller->mode=='full' || !$controller->mode)?'checked="checked"':'' ?> /> <?php echo t('Search Box and Results')?><br />
				<input name="mode" type="radio" value="search" <?php echo ($controller->mode=='search')?'checked="checked"':'' ?> /> <?php echo t('Search Box Only') ?><br />
				<input name="mode" type="radio" value="results" <?php echo ($controller->mode=='results')?'checked="checked"':'' ?> /> <?php echo t('Results Only')?>
			</div>
			<div class="ccm-note">
				<?php echo t("If you include the search form and the results as different blocks, the results block must at least include all of the search block's searchable properties.") ?>
			</div>
		</div> 
		
		
		<div class="ccm-block-field-group">
			<h2><?php  echo t('Searchable Properties')?></h2>
			
			<select id="imageSearch_searchAttrsSelector" name="imageSearch_searchAttrsSelector">
				<option value="none"><?php echo t('------') ?></option>
				
				<?php  foreach( $controller->getDefaultSearchableAttrs() as $key=>$val ){ ?>
					<option value="<?php echo  $key ?>"><?php echo $val ?></option>
				<?php  } ?>
				 
				<?php  
				$attribs = FileAttributeKey::getList(); 
				foreach( $attribs as $attrib ){ 
					$attrHandle=$attrib->getAttributeKeyHandle();
					$attrType=$attrib->getAttributeType();
					$typeHandle=$attrType->getAttributeTypeHandle(); 
					if( strtolower(trim($attrHandle))=='tag' || strtolower(trim($attrHandle))=='tags' ) continue;
					?>
					<option value="<?php echo $attrHandle ?>" ><?php echo  $attrib->getAttributeKeyName() ?></option>
				<?php  } ?>
			</select> 
			<input name="add" type="button" value="<?php echo t('+')?>" onclick="tonyImageSearchEdit.addSearchAttribute()" />         
		
			<div id="imageSearch_searchAttributes">
				
			</div>  
			
			<script>
			<?php   
			$searchAttrs = explode( ',' , $controller->searchableAttributes ); 
			$defaultSearchDetails=$controller->getDefaultSearchableAttrs(); 
			
			foreach( $searchAttrs as $attrHandle ){ 
				if( array_key_exists( $attrHandle, $defaultSearchDetails) ){
					$keyName=$defaultSearchDetails[$attrHandle]; 
				}else{
					$attrKey = FileAttributeKey::getByHandle( $attrHandle );
					if( !is_object($attrKey) ) continue; 
					$keyName = $attrKey->getAttributeKeyName(); 
				}			
				?> 
				var attrObj=new Object();
				attrObj.handle = "<?php echo $attrHandle ?>";
				attrObj.nm = "<?php echo str_replace('"','',$keyName ) ?>"; 
				tonyImageSearchEdit.existingSearchAttrObjs.push( attrObj ); 
			<?php  } ?>
			tonyImageSearchEdit.addExistingSearchAttrs(); 
			</script>
		</div> 	
		
		<div class="ccm-block-field-group">
			<h2><?php  echo t('Filter by File Sets (optional)')?></h2>
			<?php  if( !count($fileSets) ){ 
				echo '<div>'.t("No file sets found").'</div>';
			}else{ ?>
				<div class="imageSearch_setListLimitHeight">
					<?php  foreach($fileSets as $fileSet){ ?>
					<div>
						<input name="fsIDs[]" type="checkbox" value="<?php echo $fileSet->getFileSetID() ?>" <?php echo (in_array($fileSet->getFileSetID(),$setIdsArray))?'checked':'' ?> />
						<?php echo $fileSet->getFileSetName() ?>		
					</div>
					<?php  } ?> 
				</div> 
			<?php   } ?>
			<div class="ccm-note" style="margin-top:4px"><?php echo  t('Use the %sfile manager%s to place images into sets','<a href="'.View::url('/dashboard/files').'">','</a>') ?></div>  
		</div>	
		
		<div class="ccm-block-field-group">
		  <h2><?php  echo t('Exclude File Sets (optional)')?></h2>
		  <?php  if( !count($fileSets) ){ 
			echo '<div>'.t("No file sets found").'</div>';
		  }else{ ?>
			<div class="imageSearch_setListLimitHeight">
				<?php  foreach($fileSets as $fileSet){ ?>
				<div>
					<input name="excluded_fsIDs[]" type="checkbox" value="<?php echo $fileSet->getFileSetID() ?>" <?php echo (in_array($fileSet->getFileSetID(),$excludedSetIdsArray))?'checked':'' ?> />
					<?php echo $fileSet->getFileSetName() ?>		
				</div>
				<?php  } ?>  
			</div>
		 <?php   } ?>
		</div>	 
		
		<div id="imageSearch_searchOptions" style="display:<?php echo ($controller->mode!='results')?'block':'none'?>" class="ccm-blockEditPane">
		
			<div class="ccm-block-field-group">
				<h2><?php  echo t('Search Options')?></h2> 
				
				<?php echo  t('Search Box Title: ') ?><input name="searchTitle" type="text" value="<?php echo  imageSearch_entities($controller->searchTitle)  ?>"  />
				
				<div style="margin-top:8px;">
				<input id="showSearchTarget" onchange="tonyImageSearchEdit.showSearchTarget(this);" name="showSearchTarget" type="checkbox" value="1" <?php echo (intval($controller->searchTargetCID))?'checked':'' ?> /> 
				<?php echo t('Use a seperate page to display search results') ?>
				</div>
				
				<div id="ccm-image-search-page-target-wrap" <?php  if (!intval($controller->searchTargetCID)){ ?> style="display: none"<?php   } ?>>
					<?php   
					$formPgSelector = Loader::helper('form/page_selector');
					echo $formPgSelector->selectPage('searchTargetCID', $controller->searchTargetCID, 'tonyImageSearchEdit.setPageTarget');
					?>
					<div class="ccm-note"><?php echo t("The target page have another instance of this block, with results shown.")?></div>
				</div> 
			</div> 
		
		</div>		 
		
	</div>		
			
	
	
	<div id="ccm-blockEditPane-results" style="display:none" class="ccm-blockEditPane"> 
	
		<div class="ccm-block-field-group">
			<h2><?php echo  t('Limit to File Types (optional)') ?></h2> 
			<div> 
				<?php 
				$fileTypeIdsArray = explode( ',', $controller->fileTypeIds);
				$typesArray = FileList::getTypeList(); 
				foreach($typesArray as $typeNum){ 
					$typeName = FileType::getGenericTypeText($typeNum);  
					?> 
					<div>
						<input name="typeIDs[]" type="checkbox" value="<?php echo $typeNum ?>" <?php echo (in_array($typeNum,$fileTypeIdsArray))?'checked':'' ?> />
						<?php echo $typeName ?>		
					</div>					
				<?php  } ?>
			</div> 
		</div> 
		
		<div class="ccm-block-field-group">
			<h2><?php  echo t('Results') ?></h2> 
			<div> 
				<?php echo  t('Columns: ') ?><input name="columns" type="text" value="<?php echo  intval($controller->columns)?intval($controller->columns):3  ?>" size="3" /><br /> 
				<?php echo  t('Max Rows: ') ?><input name="max_rows" type="text" value="<?php echo  intval($controller->max_rows)?intval($controller->max_rows):5  ?>" size="3" /><br /> 
			</div> 
		</div>
		
        <div class="ccm-block-field-group">
            <h2><?php  echo t('Sort By')?></h2>  
            <?php  
            $orderBy=$controller->displayOrder;
            ?>
            <select name="displayOrder">
                <option value="title" <?php echo ($orderBy=='title')?'selected':''?> >Title</option>
                <option value="date" <?php echo ($orderBy=='date')?'selected':''?> >Date Posted</option>
                <option value="filename" <?php echo ($orderBy=='filename')?'selected':''?> >File Name</option> 
                <?php  foreach($fileAttributes as $ak){ 
					if($ak->getAttributeKeyHandle()=='tag') continue;
                    $akID=$ak->getAttributeKeyID();
                    ?>
                    <option value="fak_<?php echo $akID ?>"
                        <?php echo  ($orderBy=='fak_'.$akID) ? 'selected':''?> >
                        <?php echo  $ak->getAttributeKeyName() ?>
                    </option>
                <?php  } ?> 
            </select>
              
            <input name="displayOrderDesc" type="checkbox" value="1" <?php echo (intval($controller->displayOrderDesc)>0)?'checked':'' ?> /> <?php echo  t('Descending') ?> &nbsp; 
			<input name="showSortBy" type="checkbox" value="1" <?php echo (intval($controller->showSortBy))?'checked':'' ?> onchange="tonyImageSearchEdit.showSortByAttrs(this)" onclick="tonyImageSearchEdit.showSortByAttrs(this)" /> <?php echo  t('Show') ?>  
			
        </div>	
		
		
	    <div class="ccm-block-field-group" id="imageSearch_sortByAttrsWrap" style="display:<?php echo (intval($controller->showSortBy))?'block':'none' ?>">
            <h2><?php  echo t('Allowed Sorting Options: ')?></h2> 
			<?php  
			$sortableOpts = $controller->getDefaultSortableOpts(); 
			foreach( $sortableOpts as $key => $val ){ ?>
				<div><input name="sortableBy[]" type="checkbox" value="<?php echo $key ?>" <?php echo  ( in_array( $key, $sortableByArray) ) ? 'checked' : '' ?> /> <?php echo $val ?></div>
			<?php  } ?>
			<?php  foreach($fileAttributes as $ak){ 
				if($ak->getAttributeKeyHandle()=='tag') continue;
				$akID=$ak->getAttributeKeyID();
				?>  
				<div>
				<input name="sortableBy[]" type="checkbox" value="fak_<?php echo $akID ?>" <?php echo (in_array( 'fak_'.$akID, $sortableByArray)) ? 'checked' : '' ?> />
				<?php echo  $ak->getAttributeKeyName() ?>
				</div>
			<?php  } ?>  
        </div>			 		
		
		<div class="ccm-block-field-group">
			<h2><?php  echo t('Thumbnails') ?></h2>
			
			<div> 
				<?php echo  t('Max Width: ') ?><input name="maxThumbWidth" type="text" value="<?php echo  intval($controller->maxThumbWidth)  ?>" size="3" /><?php echo  t('px') ?><br /> 
				<?php echo  t('Max Height: ') ?><input name="maxThumbHeight" type="text" value="<?php echo  intval($controller->maxThumbHeight)  ?>" size="3" /><?php echo  t('px') ?><br /> 
			</div>
		</div> 	
		
		<div>
			<div class="ccm-block-field-group">
				<h2><?php  echo t('Displayed Attributes')?></h2>
				
				<select id="imageSearch_attributeSelector" name="imageSearch_attributeSelector">
					<option value="none"><?php echo t('------') ?></option>
					
					<?php  foreach( $controller->getDefaultDetails() as $key=>$val ){ ?>
						<option value="<?php echo  $key ?>"><?php echo $val ?></option>
					<?php  } ?>
					 
					<?php  
					$attribs = FileAttributeKey::getList(); 
					foreach( $attribs as $attrib ){ 
						$attrHandle=$attrib->getAttributeKeyHandle();
						$attrType=$attrib->getAttributeType();
						$typeHandle=$attrType->getAttributeTypeHandle(); 
						if( strtolower(trim($attrHandle))=='tag' || strtolower(trim($attrHandle))=='tags' ) continue;
						?>
						<option value="<?php echo $attrHandle ?>" ><?php echo  $attrib->getAttributeKeyName() ?></option>
					<?php  } ?>
				</select> 
				<input name="add" type="button" value="<?php echo t('+')?>" onclick="tonyImageSearchEdit.addAttribute()" />         
			
				<div id="imageSearchAvailableAttributes">
					
				</div>  
				
				<script>
				<?php  
				$shownAttrs = explode( ',' , $controller->shownAttributes );
				$shownLabels = explode( ',' , $controller->shownLabels ); 
				$defaultDetails=$controller->getDefaultDetails(); 
				
				foreach( $shownAttrs as $attrHandle ){
					
					if( array_key_exists( $attrHandle, $defaultDetails) ){
						$keyName=$defaultDetails[$attrHandle];
						//$attrVal = $fv->getAttribute( $attrHandle );
					}else{
						$attrKey = FileAttributeKey::getByHandle( $attrHandle );
						if( !is_object($attrKey) ) continue; 
						$keyName = $attrKey->getAttributeKeyName();
						//$attrVal = $fv->getAttribute( $attrKey->getAttributeKeyHandle() );
					}			
					?> 
					var attrObj=new Object();
					attrObj.handle = "<?php echo $attrHandle ?>";
					attrObj.nm = "<?php echo str_replace('"','',$keyName ) ?>"; 
					attrObj.labelShown = <?php echo ( in_array($attrHandle,$shownLabels) ) ? 1 : 0 ?>; 
					tonyImageSearchEdit.existingAttrObjs.push( attrObj ); 
				<?php  } ?>
				tonyImageSearchEdit.addExisting();
				</script>
			</div> 
			
			<div class="ccm-block-field-group"> 
				<input name="hideEmptyAttrs" type="checkbox" value="1" <?php echo ($controller->hideEmptyAttrs)?'checked="checked"':'' ?> /> 
				<?php  echo t("Hide details that haven't been set")?>
			</div> 
		</div> 		    
		   
		<div class="ccm-block-field-group">
			<h2><?php  echo t('Link Mode')?></h2> 
			<input name="linkMode" type="radio" value="open" <?php echo  ($controller->linkMode=='open' || !$controller->linkMode) ? 'checked="checked"' : '' ?> /><?php echo t('Open') ?>&nbsp; 
			<input name="linkMode" type="radio" value="download" <?php echo  ($controller->linkMode=='download') ? 'checked="checked"' : '' ?> /><?php echo t('Download') ?>&nbsp; 
			<input name="linkMode" type="radio" value="link" <?php echo  ($controller->linkMode=='link') ? 'checked="checked"' : '' ?> /><?php echo t('Page Link') ?>&nbsp; 
			<input name="linkMode" type="radio" value="off" <?php echo  ($controller->linkMode=='off') ? 'checked="checked"' : '' ?> /><?php echo t('Off') ?>
		</div>  		   
		   
		<div id="imageSearch_linkModePageLinkOptions" style="display:<?php echo ($controller->linkMode=='link')?'block':'none' ?>">
			<div class="ccm-block-field-group">
				<h2><?php  echo t('Detail Page')?></h2> 
				<input id="showDetailTarget" onchange="tonyImageSearchEdit.showDetailTarget(this);" name="showDetailTarget" type="checkbox" value="1" <?php echo (intval($controller->detailTargetCID))?'checked':'' ?> /> 
				<?php echo t('Link all results to another single page on your site') ?>
				
				<div id="ccm-image-search-detail-page-target-wrap" <?php  if (!intval($controller->detailTargetCID)){ ?> style="display: none"<?php   } ?>>
					<?php   
					$formPgSelector = Loader::helper('form/page_selector');
					echo $formPgSelector->selectPage('detailTargetCID', $controller->detailTargetCID, 'tonyImageSearchEdit.setPageTarget');
					?>
					<div class="ccm-note"><?php echo t("The page must handle a fID parameter in the url's querystring")?></div>
				</div>
			</div>   
			
			<div>
				<h2><?php  echo t('Image/File Link URL Attribute (Optional)')?></h2> 
				<select name="linkAttributeHandle">
					<option value=""><?php echo t('None') ?></option>
					<?php  
					$attribs = FileAttributeKey::getList();  
					foreach( $attribs as $attrib ){ 
						$attrHandle=$attrib->getAttributeKeyHandle();
						if( method_exists($attrType,'getAttributeTypeHandle') ){ 
							$attrType=$attrib->getAttributeType();
							$typeHandle=$attrType->getAttributeTypeHandle();
							if($typeHandle!='text' && $typeHandle!='number') continue;
						}
						?>
						<option value="<?php echo $attrHandle ?>" <?php echo ($controller->linkAttributeHandle==$attrHandle)?'selected="selected"':''?>><?php echo  $attrib->getAttributeKeyName() ?></option>
					<?php  } ?>
				</select>
				<div class="ccm-note" style="margin-top:4px;"><?php echo t('Set this to have each image link to a different page (overriding the "Detail Page" set above). Create and set this attribute through the %sfile manager%s. Attributes must be Text (with a url) or Number (with a cID)','<a target="_blank" href="'.View::url('/dashboard/files').'">','</a>') ?></div>
			</div>	 
		</div>
		
	</div>  
       
</div> 